## Memory Slices

Memory Slices — efficient way to allocate groups of equal-sized chunks of memory

## Functions

gpointer | g_slice_alloc ()
gpointer | g_slice_alloc0 ()
gpointer | g_slice_copy ()
void | g_slice_free1 ()
void | g_slice_free_chain_with_offset ()
#define | g_slice_new ()
#define | g_slice_new0 ()
#define | g_slice_dup ()
#define | g_slice_free ()
#define | g_slice_free_chain ()

## Includes

    #include <glib.h>

## Description

Memory slices provide a space-efficient and multi-processing scalable way to allocate equal-sized pieces of memory, just like the original GMemChunks (from GLib 2.8), while avoiding their excessive memory-waste, scalability and performance problems.

To achieve these goals, the slice allocator uses a sophisticated, layered design that has been inspired by Bonwick's slab allocator (Bonwick94 Jeff Bonwick, The slab allocator: An object-caching kernel memory allocator. USENIX 1994, and Bonwick01 Bonwick and Jonathan Adams, Magazines and vmem: Extending the slab allocator to many cpu's and arbitrary resources. USENIX 2001)

It uses `posix_memalign()` to optimize allocations of many equally-sized chunks, and has per-thread free lists (the so-called magazine layer) to quickly satisfy allocation requests of already known structure sizes. This is accompanied by extra caching logic to keep freed memory around for some time before returning it to the system. Memory that is unused due to alignment constraints is used for cache colorization (random distribution of chunk addresses) to improve CPU cache utilization. The caching layer of the slice allocator adapts itself to high lock contention to improve scalability.

The slice allocator can allocate blocks as small as two pointers, and unlike `malloc()`, it does not reserve extra space per block. For large block sizes, `g_slice_new()` and `g_slice_alloc()` will automatically delegate to the system `malloc()` implementation. For newly written code it is recommended to use the new `g_slice` API instead of `g_malloc()` and friends, as long as objects are not resized during their lifetime and the object size used at allocation time is still available when freeing.

Here is an example for using the slice allocator:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16

    gchar *mem[10000];
    gint i;

    // Allocate 10000 blocks.
    for (i = 0; i < 10000; i++)
      {
        mem[i] = g_slice_alloc (50);

        // Fill in the memory with some junk.
        for (j = 0; j < 50; j++)
          mem[i][j] = i * j;
      }

    // Now free all of the blocks.
    for (i = 0; i < 10000; i++)
      g_slice_free1 (50, mem[i]);

And here is an example for using the using the slice allocator with data structures:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15

    GRealArray *array;

    // Allocate one block, using the g_slice_new() macro.
    array = g_slice_new (GRealArray);

    // We can now use array just like a normal pointer to a structure.
    array->data            = NULL;
    array->len             = 0;
    array->alloc           = 0;
    array->zero_terminated = (zero_terminated ? 1 : 0);
    array->clear           = (clear ? 1 : 0);
    array->elt_size        = elt_size;

    // We can free the block, so it can be reused.
    g_slice_free (GRealArray, array);

## Functions

### g_slice_alloc ()

    gpointer
    g_slice_alloc (gsize block_size);

Allocates a block of memory from the slice allocator. The block adress handed out can be expected to be aligned to at least 1 * sizeof (void*), though in general slices are 2 * sizeof (void*) bytes aligned, if a `malloc()` fallback implementation is used instead, the alignment may be reduced in a libc dependent fashion. Note that the underlying slice allocation mechanism can be changed with the `G_SLICE=always-malloc` environment variable.

#### Parameters

block_size | the number of bytes to allocate |

#### Returns

a pointer to the allocated memory block

Since: 2.10

### g_slice_alloc0 ()

    gpointer
    g_slice_alloc0 (gsize block_size);

Allocates a block of memory via `g_slice_alloc()` and initializes the returned memory to 0. Note that the underlying slice allocation mechanism can be changed with the `G_SLICE=always-malloc` environment variable.

#### Parameters

block_size | the number of bytes to allocate |

#### Returns

a pointer to the allocated block

Since: 2.10

### g_slice_copy ()

    gpointer
    g_slice_copy (gsize block_size,
                  gconstpointer mem_block);

Allocates a block of memory from the slice allocator and copies `block_size` bytes into it from `mem_block` .

#### Parameters

block_size | the number of bytes to allocate |
mem_block | the memory to copy |

#### Returns

a pointer to the allocated memory block

Since: 2.14

### g_slice_free1 ()

    void
    g_slice_free1 (gsize block_size,
                   gpointer mem_block);

Frees a block of memory.

The memory must have been allocated via `g_slice_alloc()` or `g_slice_alloc0()` and the `block_size` has to match the size specified upon allocation. Note that the exact release behaviour can be changed with the `G_DEBUG=gc-friendly` environment variable, also see `G_SLICE` for related debugging options.

#### Parameters

block_size | the size of the block |
mem_block | a pointer to the block to free |

Since: 2.10

### g_slice_free_chain_with_offset ()

    void
    g_slice_free_chain_with_offset (gsize block_size,
                                    gpointer mem_chain,
                                    gsize next_offset);

Frees a linked list of memory blocks of structure type `type` .

The memory blocks must be equal-sized, allocated via `g_slice_alloc()` or `g_slice_alloc0()` and linked together by a `next` pointer (similar to GSList). The offset of the `next` field in each block is passed as third argument. Note that the exact release behaviour can be changed with the `G_DEBUG=gc-friendly` environment variable, also see `G_SLICE` for related debugging options.

#### Parameters

block_size | the size of the blocks |
mem_chain | a pointer to the first block of the chain |
next_offset | the offset of the `next` field in the blocks |

Since: 2.10

### g_slice_new()

    #define             g_slice_new(type)

A convenience macro to allocate a block of memory from the slice allocator.

It calls `g_slice_alloc()` with `sizeof (@type)` and casts the returned pointer to a pointer of the given type, avoiding a type cast in the source code. Note that the underlying slice allocation mechanism can be changed with the `G_SLICE=always-malloc` environment variable.

#### Parameters

type | the type to allocate, typically a structure name |

#### Returns

a pointer to the allocated block, cast to a pointer to `type`

Since: 2.10

### g_slice_new0()

    #define             g_slice_new0(type)

A convenience macro to allocate a block of memory from the slice allocator and set the memory to 0.

It calls `g_slice_alloc0()` with `sizeof (@type)` and casts the returned pointer to a pointer of the given type, avoiding a type cast in the source code. Note that the underlying slice allocation mechanism can be changed with the `G_SLICE=always-malloc` environment variable.

#### Parameters

type | the type to allocate, typically a structure name |

Since: 2.10

### g_slice_dup()

    #define             g_slice_dup(type, mem)

A convenience macro to duplicate a block of memory using the slice allocator.

It calls `g_slice_copy()` with `sizeof (@type)` and casts the returned pointer to a pointer of the given type, avoiding a type cast in the source code. Note that the underlying slice allocation mechanism can be changed with the `G_SLICE=always-malloc` environment variable.

#### Parameters

type | the type to duplicate, typically a structure name |
mem | the memory to copy into the allocated block |

#### Returns

a pointer to the allocated block, cast to a pointer to `type`

Since: 2.14

### g_slice_free()

    #define             g_slice_free(type, mem)

A convenience macro to free a block of memory that has been allocated from the slice allocator.

It calls `g_slice_free1()` using `sizeof (type)` as the block size. Note that the exact release behaviour can be changed with the `G_DEBUG=gc-friendly` environment variable, also see `G_SLICE` for related debugging options.

#### Parameters

type | the type of the block to free, typically a structure name |
mem | a pointer to the block to free |

Since: 2.10

### g_slice_free_chain()

    #define             g_slice_free_chain(type, mem_chain, next)

Frees a linked list of memory blocks of structure type `type` . The memory blocks must be equal-sized, allocated via `g_slice_alloc()` or `g_slice_alloc0()` and linked together by a `next` pointer (similar to GSList). The name of the `next` field in `type` is passed as third argument. Note that the exact release behaviour can be changed with the `G_DEBUG=gc-friendly` environment variable, also see `G_SLICE` for related debugging options.

#### Parameters

type | the type of the `mem_chain` blocks |
mem_chain | a pointer to the first block of the chain |
next | the field name of the next pointer in `type` |

Since: 2.10

## Types and Values